require 'weaver/core/policy'

module Weaver
  module Dsl
    
    # Represents a PolicyStatement.  PolicyStatements are a place holder
    # for policies derived from this generic one and only contain
    # attributes defined in the sub types.  Therefore, this class is very
    # simple.     
    # 
    # Author:: Thomas Gschwind <thg@zurich.ibm.com>
    # Copyright:: IBM
    class PolicyStatement < AbstractStatement
      
      # * +id+ Symbol representing the entity, or a Core::Policy which is the entity
      # * +parent_statement+ The enclosing AbstractStatement
      def initialize(id, parent_statement)
        @@logger.debug "policy[id: #{id}]"
        super(id, Policy, parent_statement)
      end
    end
  end
end
