module Weaver
  module Dsl
    
    # A custom exception class that is used to indicate processing/parsing errors
    # in Weaver definitions.
    # *Deprecated*
    class UnknownStatementError < Exception
      
      # The statement
      attr_reader :statement
      
      # The statement's arguments
      attr_reader :arguments
      
      # A block representing a Proc
      attr_reader :block      
      
      # *Deprecated*
      def initialize(statement, args, block)
        @statement = statement
        @arguments = args
        @block = block      
        
        str = "Processing error: Unknown statement '#{@statement}'"
        if @arguments
          str +=  " with arguments: '#{@arguments}'."
        else
          str += '.'
        end        
        super str
      end
    end
  end
end
