require 'weaver/core/base.rb'
require 'weaver/deployers/plugins/iwd_deployer'
require 'weaver/providers/provider_impl'

module Weaver
  module Providers
    
    # The implementation for the provider that bridges between the Weaver model and the {Weaver::Deployers::Plugins::IwdDeployer} deployer
    # @see Weaver::Core::Provider
    # @see Weaver::Deployers::Deployer
    #
    # Author:: Ed Snible
    # Copyright:: IBM
    class Iwd_vsp < Weaver::Providers::ProviderImpl
      
      def initialize(provider)
        super(provider)
      end
      
      def deployer(properties = {}, &reporter)
        return Weaver::Deployers::Plugins::IwdDeployer.new(properties, &reporter)
      end
      
      def validate_publishability(entity, out_messages, desired_phases)
        # We handle elastic IPs
        if entity.weaver_instance_of?(:script_package)
          # We don't need to check if the script package actually exists, as there is a Rule for that in builtins
          return
        end

        # Unknown type, complaining is the default behavior        
        super
      end
    end
  end
end